#include <iostream.h>
#include <conio.h>
struct node
{
	int key;
	int count;
	node *Left;
	node *Right;
};
class Tree
{
  private:
   node* root; // .
   void  DisposeTree (node *);
   void  printTree (node*, int);
   void  Delete (node**, int);
   void  del (node**, node *);
  public:
   Tree() { root = NULL; };
   ~Tree();
   void creat_Tree();
   void look_Tree();
   void add_Tree();
   void delete_Tree();
   void search (int, node **);
   node*  getTree() {return root;};
};

struct zveno
{
  int element;
  Tree ukTree;
  zveno* sled;
};

class ring
{
  private:
    zveno* ukring;
  public:
    ring() { ukring = NULL; };
    ~ring();
    void create();
    void look();
    void add_after(int, zveno *);
    void add_befor(int, zveno *);
    void Delete (zveno *);
    void delete_next (zveno *);
    int poisk (int, zveno**);
    zveno** getring() { return &ukring;};
};

void ring::create() // .
{
  zveno* ukzv;
  int elem;

  cout << "\n  ..." << endl;
  cout << "   (  0): \n";
  cout << "-->";
  cin >> elem;
  if (elem!=0)
  {
    ukzv = ukring = new (zveno);
    (*ukzv).element = elem;
    (*ukzv).ukTree.creat_Tree();
    cout << "\n-->";
    cin >> elem;
    while  (elem!=0)
    {
      (*ukzv).sled = new (zveno);
      ukzv = (*ukzv).sled;
      (*ukzv).element = elem;
      (*ukzv).ukTree.creat_Tree();
      cout << "\n-->";
      cin >> elem;
   }
   ukzv->sled = ukring;
  }
}

ring::~ring()
{
  zveno* ukzv;

  ukzv = ukring;
  while (ukring!=NULL)
    if  (ukzv->sled == ukring)
    { ukring = NULL;
      ukzv->ukTree.~Tree();
      delete ukzv;
    }
    else
    {
     while  (ukzv->sled->sled!=ukring)  ukzv = (*ukzv).sled;
     (*ukzv).sled->ukTree.~Tree();
     delete (*ukzv).sled;
     ukzv->sled = ukring;
     ukzv = ukring;
    }
}

void ring::look() // .
{
  zveno* ukzv;

  cout << "\n   ...";
  ukzv = ukring;
  do {
    cout << "\n-->" << (*ukzv).element << endl;
    ukzv->ukTree.look_Tree();
    ukzv = ukzv->sled;
    getch();
  } while (ukzv!=ukring);
  cout << endl;
}

void ring::add_befor (int elem, zveno *zv)
{
  zveno* ukzv;
  Tree temp;

  ukzv = new (zveno);

  temp = ukzv->ukTree;
  ukzv->element = zv->element;
  ukzv->ukTree = zv->ukTree;
  ukzv->sled = zv->sled;

  zv->element = elem;
  zv->ukTree = temp;
  zv->ukTree.creat_Tree();
  zv->sled = ukzv;
}

void ring::add_after (int elem, zveno* zv)
{
  zveno* ukzv;

  ukzv = new (zveno);
  ukzv->element = elem;
  ukzv->ukTree.creat_Tree();
  ukzv->sled = zv->sled;
  zv->sled = ukzv;
}

void ring::Delete (zveno* zv)
{
  zveno* ukzv1,*ukzv2;
  zveno* time;

  if  (zv->sled!=ukring)
  {
    time = zv->sled;
    zv->ukTree.~Tree();
    (*zv) = *((*zv).sled);
    delete time;
  }
  else
    if  (zv->sled==zv)
    {
      zv->ukTree.~Tree();
      delete ukring;
      ukring = NULL;
      cout << " ...\n";
    }
    else
    {
     ukzv2 = ukring;
     ukzv1 = ukring->sled;
     while  (ukzv1!=zv)
     {
       ukzv2 = ukzv1; ukzv1 = ukzv1->sled;
     }
     time = ukzv2->sled;
     ukzv2->sled->ukTree.~Tree();
		 ukzv2->sled = ukzv2->sled->sled;
		 delete time;
	  }
}

void ring::delete_next (zveno* zv)
{

  zveno* time;

  if  (zv->sled!=ukring)
  {
   time = zv->sled;
   zv->sled = zv->sled->sled;
   time->ukTree.~Tree();
   delete time;
  }
  else
   if  (zv->sled==zv) cout << "    !\n";
   else
   {
     time = ukring->sled;
     *((*zv).sled) = (*(*(*zv).sled).sled);
     time->ukTree.~Tree();
     delete time;
   }
}

int ring::poisk (int elem, zveno** Res)
{
  zveno*  ukzv;
  int vozvr = 0;

  if  (*(getring())==NULL) cout << "  ...\n";
  else
  {
    ukzv = ukring;
    while  (ukzv->sled!=ukring && (*Res)==NULL)
    {
      if  (ukzv->element==elem)
        { vozvr = 1; *Res = ukzv;}
      ukzv = ukzv->sled;
    }
    if  ((*Res)==NULL)
     if  (ukzv->element==elem)
        {  vozvr = 1; *Res = ukzv;  }
  }
  return vozvr;
}

Tree::~Tree()
{
   DisposeTree (root); root = NULL;
}

void  Tree::DisposeTree (node *p)
{
  if  (p!=NULL)
  {
    DisposeTree (p->Left); DisposeTree (p->Right);
    delete p;
  }
}

void Tree::search (int x, node **p)
{
  if (*p==NULL)
  {
    *p= new (node); (**p).key = x; (**p).count = 1;
    (**p).Left = (**p).Right = NULL;
  }
  else  if  (x<(**p).key) search (x, &((**p).Left));
        else
         if  (x>(**p).key) search (x, &((**p).Right));
         else  (**p).count += 1;
}

void Tree::creat_Tree()
{
  int elem;

  cout << "    (  0):\n";
  cin >> elem;
  while  (elem!=0)
  {
     search (elem,&root);
     cin >>elem;
  }
}

void Tree::look_Tree()
{
  if  (root==NULL) cout << "  ...\n";
  else  printTree (root,0);
}

void Tree::printTree (node* w, int L)
{
  if  (w!=NULL)
  {
     printTree (w->Left,L+1);
     for (int i=1;i<=L;i++) cout <<"  ";
     cout << w->key <<endl;
     printTree (w->Right,L+1);
  }
}

void Tree::add_Tree()
{
  int k;

  cout << "\n    (  0):\n";
  cin >> k;
  cout << " ";
  while  (k!=0)
  {  search (k,&(root));
     cin >> k;
     cout << " ";
  }
}

void Tree::delete_Tree()
{
  int elem;

  if (root==NULL) cout << "  ...\n";
  else
  {
    cout <<"    : ";
    cin >> elem;
    cout << endl;
    Delete (&root,elem);
  }
}

void Tree::Delete (node** d, int k)
{
  node *q;
  node *s;

  if  (*d==NULL) cout <<"        ...\n";
  else
   if  (k<(**d).key)  Delete (&((**d).Left),k);
   else
    if  (k>(**d).key) Delete (&((**d).Right),k);
    else
    {
      q = *d; s = *d;
      if  ((*q).Right==NULL)
      {
       *d = (*q).Left;
       delete s;
      }
      else
       if  ((*q).Left==NULL)
       {
          *d = (*q).Right;
          delete s;
       }
       else  del (&((*q).Left),&(*q));
    }
}

void Tree::del (node** r, node *q)
{
  node *s;

  if  ((**r).Right==NULL)
  {
    (*q).key = (**r).key; (*q).count = (**r).count;
    q = s = *r; *r = (**r).Left;
    delete s;
  }
 else  del (&((**r).Right),&(*q));
}

void main()
{
  int menu1=1,choice,elem1,elem2,menu2;
  ring A;
  zveno* Res;

  cout <<"<-------------  --------------->\n";
  cout <<"<---------\"  \"---------->\n\n";

  while  (menu1)
  {
	 cout << endl;
	 cout << "<----------   1.0 : --------->\n";
	 cout << "1.  .................. \n";
	 cout << "2.  .................... \n";
	 cout << "3.    .. \n";
	 cout << "4.    ... \n";
	 cout << "5.  ..................... \n";
	 cout << "6.    .... \n";
	 cout << "7.    -. \n";
	 cout << "8.  .................... \n";
	 cout << "9. ................................. \n";
	 cout << "     <Enter> : ";
	 cin >> choice; cout << endl;
	 switch (choice)
	 {
           case 1:
                  if  (*(A.getring())==NULL) A.create();
                  else  cout <<"  ...\n";
                  break;
           case 2:
                  if  (*(A.getring())==NULL) cout <<" ...\n";
                  else  A.look();
                  break;
           case 3:
                  if  (*(A.getring())==NULL) cout <<" ...\n";
                  else
                  {
                    Res = NULL;
                    cout << " ,   ";
                    cout << "   : ";
                    cin >> elem1; cout << endl;
                    if  (A.poisk (elem1,&Res))
                    {
                      cout << " ,  ";
                      cout << "  : ";
                      cin >> elem2;
                      cout << endl;
                      A.add_after (elem2,Res);
                    }
                    else
                       cout << " " << elem1 <<"  .\n";
                  }
                  break;
           case 4:
                  if  (*(A.getring())==NULL) cout <<" ...\n";
                  else
                  {
                    Res = NULL;
                    cout << " ,   ";
                    cout << "   : ";
                    cin >> elem1; cout << endl;
                    if  (A.poisk (elem1,&Res))
                    {
                      cout << " ,  ";
                      cout << "  : ";
                      cin >> elem2;
                      cout << endl;
                      A.add_befor (elem2,Res);
                    }
                    else
                      cout << " " << elem1 <<"  .\n";
                  }
                  break;
           case 5:
                  if  (*(A.getring())==NULL) cout <<" ...\n";
                  else
                  {
                    Res = NULL;
                    cout << " , ";
                    cout << "  : ";
                    cin >> elem1; cout << endl;
                    if  (A.poisk (elem1,&Res)) A.Delete (Res);
                    else  cout << " ...\n";
                  }
                  break;
           case 6:
                  if  (*(A.getring())==NULL) cout <<" ...\n";
                  else
                  {
                    Res = NULL;
                    cout << " ,  ";
                    cout << "  : ";
                    cin >> elem1; cout << endl;
                    if  (A.poisk (elem1,&Res)) A.delete_next (Res);
                    else  cout << " ...\n";
                  }
                  break;
           case 7:
                  if  (*(A.getring())==NULL) cout <<" ...\n";
                  else
                  {
                     Res = NULL;
                     cout << "  : ";
                     cin >> elem1; cout << endl;
                     if  (A.poisk (elem1,&Res))
                     {
                       menu2 = 1;
                       while  (menu2)
                       {
                         cout << endl;
                         cout << "<---------- M 1.1 : --------->\n";
                         cout << "1.  .............\n";
                         cout << "2.  ...............\n";
                         cout << "3.    ..\n";
                         cout << "4.    ...\n";
                         cout << "5.  ...............\n";
                         cout << "6.    ..........\n";
                         cout << "     <Enter>: ";
                         cin >> choice; cout << endl;
                         switch (choice)
                         {
                           case 1:
                                   if  ((*Res).ukTree.getTree()==NULL)
                                         (*Res).ukTree.creat_Tree();
                                   else  cout << " ...\n";
                                   break;
                           case 2: (*Res).ukTree.look_Tree(); break;
                           case 3: (*Res).ukTree.add_Tree(); break;
                           case 4: (*Res).ukTree.delete_Tree(); break;
                           case 5:
                                   if  ((*Res).ukTree.getTree()==NULL)
                                           cout << "  ...\n";
                                   else  (*Res).ukTree.~Tree();
                                   break;
                           case 6: menu2 = 0; break;
                         }
                       }
                     }
                     else  cout << " " << elem1 <<"  .\n";
                  }
                  break;
           case 8:
                  if  (*(A.getring())==NULL) cout <<" ...\n";
                  else A.~ring();
                  break;
           case 9:
                  A.~ring();
                  menu1 = 0;
                  break;
         } //End Case
  } //End while
} 